#include <windows.h>


char * OpenGame()
{
	static TCHAR szFilter[] = TEXT ("All Files\0*.*;\0\0") ;
	static TCHAR szFileName [MAX_PATH], szTitleName [MAX_PATH] ;
	static OPENFILENAME ofn ;
	memset(&ofn,0,sizeof (OPENFILENAME));

	ofn.lStructSize       = sizeof (OPENFILENAME) ;
	ofn.lpstrFilter       = szFilter ;
	ofn.lpstrFile         = szFileName ;          // Set in Open and Close functions
	ofn.nMaxFile          = MAX_PATH ;
	ofn.lpstrFileTitle    = szTitleName ;          // Set in Open and Close functions
	ofn.nMaxFileTitle     = MAX_PATH ;



	GetOpenFileName (&ofn) ;
	return ofn.lpstrFile;
}


void setcolor(unsigned short color)
{
HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
SetConsoleTextAttribute(hcon,color);
}
void gotoxy(int x, int y)
{
HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
COORD cord;
	cord.X=x;
	cord.Y=y;
	SetConsoleCursorPosition(hcon,cord);
}
int PRINT_LENGTH=13;
int disp_buffer(unsigned int disp_len,char buffer[])
{
	int i,j,k;
	
	disp_len=disp_len-disp_len%PRINT_LENGTH;
	if (disp_len==0) return (-1);
	k=0;
	for (i=0; i<disp_len ; i++)
	{
		if (i%PRINT_LENGTH==0)
		printf("%04X: ",i&0x7fff);
		j=k&0xF;
		if (j%4==0 && (j!=0))
		printf("-");
		else
		printf(" ");


	printf("%02X",(unsigned char)buffer[i]);
	k++;

    if ((i+1)%PRINT_LENGTH==0)
	{
	printf("  ");
		for (j=0; j<PRINT_LENGTH ; j++)
		{
	    if (buffer[(i&0x7fff)+j-PRINT_LENGTH+1]<0x20 || buffer[(i&0x7fff)+j-PRINT_LENGTH+1]>0x80)
	       printf (".");
	    else
	       printf ("%c",buffer[(i&0x7fff)+j-PRINT_LENGTH+1]);
		}
	printf("\n");
	k=0;
	}
	}

   return(0);
}

int comp_buffer(unsigned int disp_len,char buffer1[],char buffer2[])
{
	int i,j;
	char *buffer=buffer1;
	if (disp_len==0) return (-1);

	for (i=0; i<disp_len ; i++)
	{

		if ((i & 0xf)==0)
		printf("%04X: ",i&0x7FFF);
		if ((i & 0xf)==4||(i & 0xf)==8||(i & 0xf)==0xC)
		printf("-");
		else
		printf(" ");


	if (buffer1[i]!=buffer2[i])
	{
		setcolor(FOREGROUND_RED);
		printf("%02X",(unsigned char)buffer[i]);
		setcolor(0x07);
	}
	else
		printf("%02X",(unsigned char)buffer[i]);


    if ((i & 0xf)==0xf)
	{
	printf("  ");
		for (j=0; j<16 ; j++)
		{
	    if (buffer[(i&0x7ff0)+j]<0x20 || buffer[(i&0x7ff0)+j]>0x80)
	       printf (".");
	    else
			if (buffer[(i&0x7ff0)+j]!=buffer2[(i&0x7ff0)+j])
			{
				setcolor(FOREGROUND_RED);
				printf ("%c",buffer[(i&0x7ff0)+j]);
				setcolor(0x7);
			}
			else
				printf ("%c",buffer[(i&0x7ff0)+j]);

		}
		printf("\n");
	}

	}//for disp len

   return(0);
}

int get32(char *buffer)
{
	int i,j;
	for (i=0;i<4;i++)
	{
		j=j<<8;
		j=j|(BYTE)buffer[i];
	}
	return j;
}

int get32L(char *buffer)
{
	int i,j;
	for (i=3;i>-1;i--)
	{
		j=j<<8;
		j=j|(BYTE)buffer[i];
	}
	return j;
}

BYTE swap8(BYTE a)
{
	int i;
	BYTE b;
	for(i=0;i<8;i++)
	{
		b<<=1;
		b|=(a>>i)&1;
	}
	return b;
}
int swapbuffer(char *buffer)
{
	int i;
	for (i=0;i<8;i++)
	{
		buffer[i]=swap8(buffer[i]);
	}
}